// editluep.h
/****************************************************************************/
/*
**        E D I T L U E P . H
**
** Apualiohjelmia console.c:n helppoon kyttnottoon C++:ssa
** Tm tiedosto muuttaa mjonot.c:n lue_jono:n ja lue_jono_oletus
** kyttmn editoivaa versiota EditString.
** Tss on mys toteutus omien lyhenteitten kyttn (ks lyhenne.c)
** Katso tarkemmin editlue.c.
**
**  Tekijt:          Vesa Lappalainen
**                    Ohjelmointikurssi 1996-
**  Tehty:            13.03.1996
**  Muutettu:
**
**  Kytt:
**   0) Projektiin tarvittaan lisksi
**        C\ALI\console.c
**        C\ALI\mjonot.
**        C\ALI\lyhenne.c
**        C\ALI\editlue.c
**        C\ALI\editluep.cpp   - jos lyhennetiedostoksi kelpaa lyhenne.lyh
**        C\ALI\wout.cpp       - jotta cout menee console.c:n kautta
**
**      Ennen knnst mritelln vakio USE_CONSOLE.
**      Mikli ko. vakiota ei ole mritelty, ei tmn tiedoston
**      aliohjelmat tee mitn, eik em. tiedostoja tarvitse
**
**   0) #include "wout.h" niissa tiedostoissa joissa cout halutaan muuttaa
**   1) #include "editluep.h" ja
**      ohjelmassa maaritellaan jossakin olio
**        cEditLue editlue(lyh);
**      miss lyh on mahdollisen lyhennetiedoston nimi.
** tai
**   1) liitetaan editluep.cpp projektiin, jolloin ei tule lyhennetiedostoa
*/

#ifndef __EDITLUEP_H
#define __EDITLUEP_H
#include <string.h>
#include "editlue.h"
#include "wout.h"
#ifdef USE_CONSOLE
class cEditLue {
  char *lyh;
public:
  cEditLue(const char *alyh=NULL) {
    lyh = NULL;
    if ( alyh ) lyh = new char[strlen(alyh)+1];
    if ( lyh ) strcpy(lyh,alyh);
    edit_alusta(lyh);
  }
  ~cEditLue() { edit_vapauta(lyh); if ( lyh ) delete [] lyh;}
};
#endif /* USE_CONSOLE  */
#endif /* __EDITLUEP_H */
